//+------------------------------------------------------------------+
//|                                              #MTF_HULL_TREND.mq4 |
//|------------------------------------------------------------------+

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  LimeGreen
#property  indicator_color2  Red
#property  indicator_color3  Yellow
#property  indicator_minimum 0
#property  indicator_maximum 1
#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------*/

extern int    TimeFrame = 60;
extern bool SoundAlert = true;

//---- indicator buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double alertBar;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
   
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color1);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel(0,"BuyZone");
   
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color2);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexLabel(1,"SellZone");
   
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color3);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexLabel(2,"NoTradeZone");   

//---- name for DataWindow and indicator subwindow label

//---- name for DataWindow and indicator subwindow label   

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("#MTF_ErgodicMA("+TimeFrameStr+")");

  }

//----

   return(0);
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
  {

   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted(); 

// Plot defined time frame on to current time frame

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= Bars-1;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  

   ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"ErgodicMA",0,y);
   ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"ErgodicMA",1,y);
   ExtMapBuffer3[i]=iCustom(NULL,TimeFrame,"ErgodicMA",2,y);
   if(ExtMapBuffer1[i]== ExtMapBuffer3[i] && SoundAlert == true && Bars>alertBar) {Alert("#MTF_ErgodicMA Alert changing Up " + Symbol() + " on the " +  Period() + " minute chart.");alertBar = Bars;}
   if(ExtMapBuffer2[i]== ExtMapBuffer3[i] && SoundAlert == true && Bars>alertBar) {Alert("#MTF_ErgodicMA Alert changing Down " + Symbol() + " on the " +  Period() + " minute chart.");alertBar = Bars;}
    }
   return(0);
    }
//+------------------------------------------------------------------+